#ifndef __SHADERS__H__
#define __SHADERS__H__

#include <GL/glew.h>

// type: GL_VERTEX_SHADER, GL_FRAGMENT_SHADER, ...
GLuint load_shader(GLenum type, char *filename);
GLuint load_shader_from_memory(GLenum type, GLchar *shader_source);

GLuint link_and_validate_program(GLuint program);

int create_default_shaders_from_files_and_create_and_link_program(
		char *vertex_shader_filename, char *fragment_shader_filename,
		GLuint *vertex_shader, GLuint *fragment_shader, GLuint *shader_program);

int create_default_shaders_from_sources_and_create_and_link_program(
		char *vertex_shader_source, char *fragment_shader_source,
		GLuint *vertex_shader, GLuint *fragment_shader, GLuint *shader_program);

void print_shader_info_log(GLuint obj);
void print_program_info_log(GLuint obj);

#endif
